% =========================================================================
% Code for "Pandemic Recessions and Contact Tracing"
% by Leonardo Melosi and Matthias Rottner
% Journal of the European Economic Association, forthcoming
% This function helps to solve the optimal policy for the economy without 
% tracing
% =========================================================================

function MIN = eqm_SIRAC_get_err(x,t,P,pf_lambda_c,pf_lambdab_s,pf_lambdatau_s,pf_pi_s2, ...
    pf_c_s,pf_c_i,pf_c_r,pf_n_s,pf_w,pf_N_Meet,pf_S,pf_I,pf_A,pf_R,pf_RI,pf_RA)  %x,t,state,pf,P,G


% Preallocate function output
R = zeros(size(x));
Rdim = size(R,2);


MIN=NaN*ones(3,Rdim);
for j = 1:Rdim  
    % Policy Function Guesses
    pf_up_n_r    = x(1,j); 
    pf_up_n_i    = x(2,j);
    pf_up_n_s  = x(3,j); 

    MIN(1,j) = (1+P.alpha_c*pf_lambda_c(t,1))*pf_c_i(t,1)-  (P.phi*pf_w(t,1)*pf_up_n_i ); 
       
    MIN(2,j) = pf_lambda_c(t,1).*( pf_S(t,1)*pf_c_s(t,1) +   pf_RI(t,1)*pf_c_r(t,1) + pf_RA(t,1)*pf_c_s(t,1) + ...
        pf_A(t,1)*pf_c_s(t,1) + P.alpha_c*pf_I(t,1)*pf_c_i(t,1)    ) - ...
          ((1+pf_lambda_c(t,1))*pf_c_r(t,1) - pf_w(t,1)*pf_up_n_r)*(pf_S(t,1)+pf_R(t,1) + pf_A(t,1)) ;
                
    MIN(3,j) = -P.theta*pf_up_n_s.^(1/P.eta-1) + pf_w(t,1)*pf_lambdab_s(t,1) +...
        pf_lambdatau_s(t,1)*pf_pi_s2(t,1)*(pf_A(t,1)*pf_n_s(t,1)./pf_N_Meet(t,1));  
  

end

end