% =========================================================================
% Code for "Pandemic Recessions and Contact Tracing"
% by Leonardo Melosi and Matthias Rottner
% Journal of the European Economic Association, forthcoming
% This function calculates the PMF of contacts for specific groups
% Provides option to use built-in function or self-programmed one for the
% PMF of the binomial distribution
% =========================================================================

function [f_k] = pmf_contacts_withA_get_err(cons_agent,labor_agent,P,pf_c_s_t,pf_A_t,pf_n_s_t,pf_Cons_Meet_t,pf_N_Meet_t,pf_Pop_Meet_t)


C_A = pf_c_s_t*pf_A_t;
N_A = pf_n_s_t*pf_A_t;
C_Pop = pf_Cons_Meet_t; 
N_Pop = pf_N_Meet_t; 

        
if P.binopdf == 1
    f1 = binopdf(P.grid,round(P.chi*P.varphi_c*cons_agent),(1/P.chi)*C_A/C_Pop);
    f2 = binopdf(P.grid,round(P.chi*P.varphi_n*labor_agent),(1/P.chi)*N_A/N_Pop);
    f3 = binopdf(P.grid,round(P.chi*P.varphi),(1/P.chi)*pf_A_t/pf_Pop_Meet_t);
elseif P.binopdf == 2
    f1 = binopdf2(P.grid,round(P.chi*P.varphi_c*cons_agent),(1/P.chi)*C_A/C_Pop);
    f2 = binopdf2(P.grid,round(P.chi*P.varphi_n*labor_agent),(1/P.chi)*N_A/N_Pop);
    f3 = binopdf2(P.grid,round(P.chi*P.varphi),(1/P.chi)*pf_A_t/pf_Pop_Meet_t);
end
% Aggregate Binomal Function
f_k = zeros(P.k_s_max+1,1);

    for k = 1:P.k_s_max+1  % Loop over all potential outcomes
        out= [];
            % Sum up similarly to the description in the paper for k1,k2,k3
            for i = 1:k
                for j = 1:k+1-i
                    out_t = f1(i)*f2(j)*f3(k+1+1-i-j);
                    out = [out out_t];
                end
            end
        f_k(k) = sum(out);
    end
    
   
end

