% =========================================================================
% Code for "Pandemic Recessions and Contact Tracing"
% by Leonardo Melosi and Matthias Rottner
% Journal of the European Economic Association, forthcoming
% This function calculates the PMF of contacts for specific groups
% =========================================================================

function [f_k] = pmf_contacts_withT(cons_agent,labor_agent,t,P,pf)


C_S = pf.c_s(t,1)*pf.T(t,1);
N_S = pf.n_s(t,1)*pf.T(t,1);
C_Pop = pf.Cons_Meet(t,1); 
N_Pop = pf.N_Meet(t,1); 

        
f1 = binopdf(P.grid,round(P.chi*P.varphi_c*cons_agent),(1/P.chi)*C_S/C_Pop);
f2 = binopdf(P.grid,round(P.chi*P.varphi_n*labor_agent),(1/P.chi)*N_S/N_Pop);
f3 = binopdf(P.grid,round(P.chi*P.varphi),(1/P.chi)*pf.T(t,1)/pf.Pop_Meet(t,1));


% Aggregate Binomal Function
f_k = zeros(P.k_s_max+1,1);

    for k = 1:P.k_s_max+1  % Loop over all potential outcomes
        out= [];
            % Sum up similarly to the description in the paper for k1,k2,k3
            for i = 1:k
                for j = 1:k+1-i
                    out_t = f1(i)*f2(j)*f3(k+1+1-i-j);
                    out = [out out_t];
                end
            end
        f_k(k) = sum(out);
    end
end

